Index: palm/trunk/SOURCE/land_surface_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/land_surface_model_mod.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -291,5 +294,6 @@
 
     USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  rd_mpi_io_surface_filetypes, wrd_mpi_io, wrd_mpi_io_surface
+        ONLY:  rd_mpi_io_check_array, rd_mpi_io_surface_filetypes, rrd_mpi_io, rrd_mpi_io_surface, &
+               wrd_mpi_io, wrd_mpi_io_surface
 
     USE statistics,                                                            &
@@ -808,5 +812,6 @@
 
     INTERFACE lsm_rrd_local
-       MODULE PROCEDURE lsm_rrd_local
+       MODULE PROCEDURE lsm_rrd_local_ftn
+       MODULE PROCEDURE lsm_rrd_local_mpi
     END INTERFACE lsm_rrd_local
 
@@ -6674,5 +6679,5 @@
        CALL wrd_mpi_io( 'lsm_end_index_h',  surf_lsm_h%end_index )
        CALL wrd_mpi_io( 'lsm_global_start_index_h', global_start_index )
-       CALL wrd_mpi_io_surface ( 't_soil_h', t_soil_h%var_2d )
+       CALL wrd_mpi_io_surface( 't_soil_h', t_soil_h%var_2d )
        CALL wrd_mpi_io_surface( 'm_soil_h',  m_soil_h%var_2d )
        CALL wrd_mpi_io_surface( 'm_liq_h', m_liq_h%var_1d )
@@ -6686,7 +6691,7 @@
                                              surface_data_to_write, global_start_index )
 
-          CALL wrd_mpi_io( 'lsm_start_index_v_' //dum,  surf_lsm_v(l)%start_index )
-          CALL wrd_mpi_io( 'lsm_end_index_v_' //dum,  surf_lsm_v(l)%end_index )
-          CALL wrd_mpi_io( 'lsm_global_start_index_v_' //dum , global_start_index )
+          CALL wrd_mpi_io( 'lsm_start_index_v_' // dum,  surf_lsm_v(l)%start_index )
+          CALL wrd_mpi_io( 'lsm_end_index_v_' // dum,  surf_lsm_v(l)%end_index )
+          CALL wrd_mpi_io( 'lsm_global_start_index_v_' // dum , global_start_index )
 
           IF ( .NOT. surface_data_to_write )  CYCLE
@@ -6708,9 +6713,9 @@
 ! Description:
 ! ------------
-!> Soubroutine reads lsm data from restart file(s)
+!> Read module-specific local restart data arrays (Fortran binary format).
 !------------------------------------------------------------------------------!
- SUBROUTINE lsm_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,              &
-                          nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,    &
-                          nys_on_file, tmp_2d, found )
+ SUBROUTINE lsm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,              &
+                               nxr_on_file, nynf, nync, nyn_on_file, nysf, nysc,    &
+                               nys_on_file, tmp_2d, found )
 
 
@@ -7305,5 +7310,133 @@
 
 
- END SUBROUTINE lsm_rrd_local
+ END SUBROUTINE lsm_rrd_local_ftn
+
+!------------------------------------------------------------------------------!
+!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE lsm_rrd_local_mpi
+
+    USE control_parameters
+
+    USE indices
+
+    USE pegrid
+
+
+    IMPLICIT NONE
+
+    CHARACTER(LEN=1) ::  dum  !< dummy to create correct string for creating variable string
+
+    INTEGER(iwp) ::  l   !< running index surface orientation
+
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  end_index
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  global_start
+    INTEGER(iwp), DIMENSION(nys:nyn,nxl:nxr) ::  start_index
+
+    LOGICAL      :: array_found
+    LOGICAL      :: ldum
+
+
+    CALL rd_mpi_io_check_array( 'c_liq_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( c_liq_av ) )  ALLOCATE( c_liq_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'c_liq_av',  c_liq_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'c_soil_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( c_soil_av ) )  ALLOCATE( c_soil_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'c_soil_av',  c_soil_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'c_veg_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( c_veg_av ) )  ALLOCATE( c_veg_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'c_veg_av',  c_veg_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'lai_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( lai_av ) )  ALLOCATE( lai_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'lai_av',  lai_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'm_liq_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( m_liq_av ) )  ALLOCATE( m_liq_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'm_liq_av',  m_liq_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'm_soil_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( m_soil_av ) )  ALLOCATE( m_soil_av(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'm_soil_av', m_soil_av, nzb_soil, nzt_soil )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'qsws_liq_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( qsws_liq_av ) )  ALLOCATE( qsws_liq_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'qsws_liq_av',  qsws_liq_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'qsws_soil_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( qsws_soil_av ) )  ALLOCATE( qsws_soil_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'qsws_soil_av',  qsws_soil_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'qsws_veg_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( qsws_veg_av ) )  ALLOCATE( qsws_veg_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'qsws_veg_av',  qsws_veg_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 't_soil_av', found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( t_soil_av ) )  ALLOCATE( t_soil_av(nzb_soil:nzt_soil,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 't_soil_av', t_soil_av, nzb_soil, nzt_soil )
+    ENDIF
+
+    CALL rrd_mpi_io( 'lsm_start_index_h',  surf_lsm_h%start_index )
+    CALL rrd_mpi_io( 'lsm_end_index_h',  surf_lsm_h%end_index )
+    CALL rrd_mpi_io( 'lsm_global_start_index_h', global_start )
+
+    CALL rd_mpi_io_surface_filetypes ( surf_lsm_h%start_index, surf_lsm_h%end_index, ldum,         &
+                                       global_start )
+
+    CALL rrd_mpi_io_surface( 't_soil_h', t_soil_h%var_2d )
+    CALL rrd_mpi_io_surface( 'm_soil_h',  m_soil_h%var_2d )
+    CALL rrd_mpi_io_surface( 'm_liq_h', m_liq_h%var_1d )
+    CALL rrd_mpi_io_surface( 't_surface_h', t_surface_h%var_1d )
+
+
+    DO  l = 0, 3
+
+       WRITE( dum, '(I1)')  l
+
+!kk    In case of nothing to do, the settings of start_index and end_index differ
+!kk    between writing and reading restart file
+!kk
+!kk    Has to be discussed with the developpers
+
+       CALL rrd_mpi_io( 'lsm_start_index_v_' // dum,  start_index )
+       CALL rrd_mpi_io( 'lsm_end_index_v_' // dum,  end_index )
+       CALL rrd_mpi_io( 'lsm_global_start_index_v_' // dum , global_start )
+
+       CALL rd_mpi_io_surface_filetypes( start_index, end_index, ldum, global_start )
+
+       IF ( MAXVAL( end_index ) <= 0 )  CYCLE
+
+       CALL rrd_mpi_io_surface( 't_soil_v(' // dum // ')', t_soil_v(l)%var_2d )
+       CALL rrd_mpi_io_surface( 'm_soil_v(' // dum // ')', m_soil_v(l)%var_2d )
+       CALL rrd_mpi_io_surface( 'm_liq_v(' // dum // ')',  m_liq_v(l)%var_1d )
+       CALL rrd_mpi_io_surface( 't_surface_v(' // dum // ')',  t_surface_v(l)%var_1d )
+
+    ENDDO
+
+ END SUBROUTINE lsm_rrd_local_mpi
 
 !------------------------------------------------------------------------------!
Index: palm/trunk/SOURCE/module_interface.f90
===================================================================
--- palm/trunk/SOURCE/module_interface.f90	(revision 4516)
+++ palm/trunk/SOURCE/module_interface.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4514 2020-04-30 16:29:59Z suehring
 ! Added global restart routines for plant-canopy model
 ! 
@@ -704,5 +707,6 @@
 
     INTERFACE module_interface_rrd_local
-       MODULE PROCEDURE module_interface_rrd_local
+       MODULE PROCEDURE module_interface_rrd_local_ftn
+       MODULE PROCEDURE module_interface_rrd_local_mpi
     END INTERFACE module_interface_rrd_local
 
@@ -1806,12 +1810,12 @@
 ! Description:
 ! ------------
-!> Read module-specific restart data specific to local MPI ranks
-!------------------------------------------------------------------------------!
- SUBROUTINE module_interface_rrd_local( map_index,                             &
-                                        nxlf, nxlc, nxl_on_file,               &
-                                        nxrf, nxrc, nxr_on_file,               &
-                                        nynf, nync, nyn_on_file,               &
-                                        nysf, nysc, nys_on_file,               &
-                                        tmp_2d, tmp_3d, found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_rrd_local_ftn( map_index,                             &
+                                           nxlf, nxlc, nxl_on_file,               &
+                                           nxrf, nxrc, nxr_on_file,               &
+                                           nynf, nync, nyn_on_file,               &
+                                           nysf, nysc, nys_on_file,               &
+                                           tmp_2d, tmp_3d, found )
 
 
@@ -1839,5 +1843,7 @@
 
 
-    IF ( debug_output )  CALL debug_message( 'module-specific read local restart data', 'start' )
+    IF ( debug_output )  THEN
+       CALL debug_message( 'module-specific read local restart data (Fortran binary)', 'start' )
+    ENDIF
 
     CALL dynamics_rrd_local(                                                   &
@@ -1965,8 +1971,45 @@
                             ) ! ToDo: change interface to pass variable
 
-    IF ( debug_output )  CALL debug_message( 'module-specific read local restart data', 'end' )
-
-
- END SUBROUTINE module_interface_rrd_local
+    IF ( debug_output )  THEN
+       CALL debug_message( 'module-specific read local restart data (Fortran binary)', 'end' )
+    ENDIF
+
+ END SUBROUTINE module_interface_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE module_interface_rrd_local_mpi
+
+    IF ( debug_output )  THEN
+       CALL debug_message( 'module-specific read local restart data (MPI-IO)', 'start' )
+    ENDIF
+
+    CALL dynamics_rrd_local
+
+!    IF ( biometeorology )       CALL bio_rrd_local
+    IF ( bulk_cloud_model )     CALL bcm_rrd_local
+    IF ( air_chemistry )        CALL chem_rrd_local
+!    CALL doq_rrd_local
+    IF ( gust_module_enabled )  CALL gust_rrd_local
+    IF ( particle_advection )   CALL lpm_rrd_local
+    IF ( land_surface )         CALL lsm_rrd_local
+    IF ( plant_canopy )         CALL pcm_rrd_local
+    IF ( ocean_mode )           CALL ocean_rrd_local
+    IF ( radiation )            CALL radiation_rrd_local
+!    IF ( salsa )                CALL salsa_rrd_local
+    IF ( urban_surface )        CALL usm_rrd_local
+    IF ( surface_output )       CALL surface_data_output_rrd_local
+
+    IF ( user_module_enabled )  CALL user_rrd_local
+
+    IF ( debug_output )  THEN
+       CALL debug_message( 'module-specific read local restart data (Fortran binary)', 'end' )
+    ENDIF
+
+ END SUBROUTINE module_interface_rrd_local_mpi
 
 
Index: palm/trunk/SOURCE/ocean_mod.f90
===================================================================
--- palm/trunk/SOURCE/ocean_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/ocean_mod.f90	(revision 4517)
@@ -25,4 +25,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -102,5 +105,6 @@
 
     USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  rrd_mpi_io, rrd_mpi_io_global_array, wrd_mpi_io, wrd_mpi_io_global_array
+        ONLY:  rd_mpi_io_check_array, rrd_mpi_io, rrd_mpi_io_global_array, wrd_mpi_io,             &
+               wrd_mpi_io_global_array
 
     USE surface_mod,                                                           &
@@ -232,5 +236,6 @@
 
     INTERFACE ocean_rrd_local
-       MODULE PROCEDURE ocean_rrd_local
+       MODULE PROCEDURE ocean_rrd_local_ftn
+       MODULE PROCEDURE ocean_rrd_local_mpi
     END INTERFACE ocean_rrd_local
 
@@ -2039,9 +2044,9 @@
 ! Description:
 ! ------------
-!> This routine reads the respective restart data for the ocean module.
-!------------------------------------------------------------------------------!
- SUBROUTINE ocean_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,           &
-                             nxr_on_file, nynf, nync, nyn_on_file, nysf,       &
-                             nysc, nys_on_file, tmp_3d, found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+ SUBROUTINE ocean_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,           &
+                                 nxr_on_file, nynf, nync, nyn_on_file, nysf,       &
+                                 nysc, nys_on_file, tmp_3d, found )
 
     USE averaging,                                                             &
@@ -2108,5 +2113,40 @@
     END SELECT
 
- END SUBROUTINE ocean_rrd_local
+ END SUBROUTINE ocean_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE ocean_rrd_local_mpi
+
+    USE averaging,                                                             &
+        ONLY:  rho_ocean_av, sa_av
+
+    USE indices,                                                               &
+        ONLY:  nxlg, nxrg, nyng, nysg, nzb, nzt
+
+    IMPLICIT NONE
+
+    LOGICAL ::  array_found  !<
+
+
+    CALL rd_mpi_io_check_array( 'rho_ocean_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rho_ocean_av ) )  ALLOCATE( rho_ocean_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rho_ocean_av', rho_ocean_av )
+    ENDIF
+
+    CALL rrd_mpi_io( 'sa', sa )
+
+    CALL rd_mpi_io_check_array( 'sa_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( sa_av ) )  ALLOCATE( sa_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'sa_av', sa_av )
+    ENDIF
+
+ END SUBROUTINE ocean_rrd_local_mpi
 
 
Index: palm/trunk/SOURCE/plant_canopy_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/plant_canopy_model_mod.f90	(revision 4517)
@@ -27,4 +27,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4515 2020-04-30 16:37:18Z suehring
 ! Rename error number again since this was recently given in -r 4511
 ! 
@@ -237,5 +240,6 @@
 
     USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  rrd_mpi_io,                                                                         &
+        ONLY:  rd_mpi_io_check_array,                                                              &
+               rrd_mpi_io,                                                                         &
                wrd_mpi_io
 
@@ -361,5 +365,6 @@
 
     INTERFACE pcm_rrd_local
-       MODULE PROCEDURE pcm_rrd_local
+       MODULE PROCEDURE pcm_rrd_local_ftn
+       MODULE PROCEDURE pcm_rrd_local_mpi
     END INTERFACE pcm_rrd_local
 
@@ -1685,12 +1690,13 @@
     END SUBROUTINE pcm_rrd_global_mpi
 
+
 !------------------------------------------------------------------------------!
 ! Description:
 ! ------------
-!> Subroutine reads local (subdomain) restart data
-!------------------------------------------------------------------------------!
-    SUBROUTINE pcm_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
-                              nxr_on_file, nynf, nync, nyn_on_file, nysf,      &
-                              nysc, nys_on_file, found )
+!> Read module-specific local restart data arrays (Fortran binary format).
+!------------------------------------------------------------------------------!
+    SUBROUTINE pcm_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,          &
+                                  nxr_on_file, nynf, nync, nyn_on_file, nysf,      &
+                                  nysc, nys_on_file, found )
 
        INTEGER(iwp) ::  k               !< 
@@ -1751,5 +1757,40 @@
        END SELECT
 
-    END SUBROUTINE pcm_rrd_local
+    END SUBROUTINE pcm_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+    SUBROUTINE pcm_rrd_local_mpi
+
+       IMPLICIT NONE
+
+       LOGICAL ::  array_found  !<
+
+
+!>     TODO: following code does not work because arrays are sized 0:pch_index along k!!!!!
+       CALL rd_mpi_io_check_array( 'pcm_heatrate_av' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( pcm_heatrate_av ) )  ALLOCATE( pcm_heatrate_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'pcm_heatrate_av', pcm_heatrate_av )
+       ENDIF
+
+       CALL rd_mpi_io_check_array( 'pcm_latentrate_av' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( pcm_latentrate_av ) )  ALLOCATE( pcm_latentrate_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'pcm_latentrate_av', pcm_latentrate_av )
+       ENDIF
+
+       CALL rd_mpi_io_check_array( 'pcm_transpirationrate_av' , found = array_found )
+       IF ( array_found )  THEN
+          IF ( .NOT. ALLOCATED( pcm_transpirationrate_av ) )  ALLOCATE( pcm_transpirationrate_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'pcm_transpirationrate_av', pcm_transpirationrate_av )
+       ENDIF
+
+    END SUBROUTINE pcm_rrd_local_mpi
+
 
 !------------------------------------------------------------------------------!
Index: palm/trunk/SOURCE/radiation_model_mod.f90
===================================================================
--- palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/radiation_model_mod.f90	(revision 4517)
@@ -28,4 +28,7 @@
 ! -----------------
 ! $Id$
+! added restart with MPI-IO for reading local arrays
+! 
+! 4495 2020-04-13 20:11:20Z raasch
 ! restart data handling with MPI-IO added
 ! 
@@ -364,5 +367,5 @@
 #endif
     USE restart_data_mpi_io_mod,                                                                   &
-        ONLY:  wrd_mpi_io
+        ONLY:  rd_mpi_io_check_array, rrd_mpi_io, wrd_mpi_io
 
     USE statistics,                                                            &
@@ -971,5 +974,6 @@
 
     INTERFACE radiation_rrd_local
-       MODULE PROCEDURE radiation_rrd_local
+       MODULE PROCEDURE radiation_rrd_local_ftn
+       MODULE PROCEDURE radiation_rrd_local_mpi
     END INTERFACE radiation_rrd_local
 
@@ -12080,9 +12084,9 @@
 ! Description:
 ! ------------
-!> Subroutine reads local (subdomain) restart data
+!> Read module-specific local restart data arrays (Fortran binary format).
 !------------------------------------------------------------------------------!
- SUBROUTINE radiation_rrd_local( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,       &
-                                nxr_on_file, nynf, nync, nyn_on_file, nysf,    &
-                                nysc, nys_on_file, tmp_2d, tmp_3d, found )
+ SUBROUTINE radiation_rrd_local_ftn( k, nxlf, nxlc, nxl_on_file, nxrf, nxrc,       &
+                                     nxr_on_file, nynf, nync, nyn_on_file, nysf,    &
+                                     nysc, nys_on_file, tmp_2d, tmp_3d, found )
 
 
@@ -12428,6 +12432,211 @@
     END SELECT
 
- END SUBROUTINE radiation_rrd_local
-
+ END SUBROUTINE radiation_rrd_local_ftn
+
+
+!------------------------------------------------------------------------------!
+! Description:
+! ------------
+!> Read module-specific local restart data arrays (MPI-IO).
+!------------------------------------------------------------------------------!
+ SUBROUTINE radiation_rrd_local_mpi
+
+    USE control_parameters
+
+    USE indices
+
+    USE kinds
+
+
+    IMPLICIT NONE
+
+    LOGICAL      ::  array_found  !<
+
+    REAL(wp), DIMENSION(nysg:nyng,nxlg:nxrg) ::  tmp  !< temporary array for reading from file
+
+
+    CALL rd_mpi_io_check_array( 'rad_net_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_net_av ) )  ALLOCATE( rad_net_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_net_av', rad_net_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_in_xy_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_lw_in_xy_av ) )  ALLOCATE( rad_lw_in_xy_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_lw_in_xy_av', rad_lw_in_xy_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_out_xy_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_lw_out_xy_av ) )  ALLOCATE( rad_lw_out_xy_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_lw_out_xy_av', rad_lw_out_xy_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_in_xy_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_sw_in_xy_av ) )  ALLOCATE( rad_sw_in_xy_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_sw_in_xy_av', rad_sw_in_xy_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_out_xy_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_sw_out_xy_av ) )  ALLOCATE( rad_sw_out_xy_av(nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_sw_out_xy_av', rad_sw_out_xy_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_in' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_lw_in ) )  ALLOCATE( rad_lw_in(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_in', tmp )
+          rad_lw_in(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_lw_in ) )  ALLOCATE( rad_lw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_in', rad_lw_in )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_in_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_lw_in_av ) )  ALLOCATE( rad_lw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_in_av', tmp )
+          rad_lw_in_av(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_lw_in_av ) )  ALLOCATE( rad_lw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_in_av', rad_lw_in_av )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_out' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_lw_out ) )  ALLOCATE( rad_lw_out(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_out', tmp )
+          rad_lw_out(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_lw_out ) )  ALLOCATE( rad_lw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_out', rad_lw_out )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_out_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  ALLOCATE( rad_lw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_out_av', tmp )
+          rad_lw_out_av(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_lw_out_av ) )  ALLOCATE( rad_lw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_lw_out_av', rad_lw_out_av )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_cs_hr' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_lw_cs_hr ) )  ALLOCATE( rad_lw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_lw_cs_hr', rad_lw_cs_hr )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_cs_hr_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_lw_cs_hr_av ) )  ALLOCATE( rad_lw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_lw_cs_hr_av', rad_lw_cs_hr_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_hr' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_lw_hr ) )  ALLOCATE( rad_lw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_lw_hr', rad_lw_hr )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_lw_hr_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_lw_hr_av ) )  ALLOCATE( rad_lw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_lw_hr_av', rad_lw_hr_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_in' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_sw_in ) )  ALLOCATE( rad_sw_in(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_in', tmp )
+          rad_sw_in(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_sw_in ) )  ALLOCATE( rad_sw_in(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_in', rad_sw_in )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_in_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  ALLOCATE( rad_sw_in_av(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_in_av', tmp )
+          rad_sw_in_av(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_sw_in_av ) )  ALLOCATE( rad_sw_in_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_in_av', rad_sw_in_av )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_out' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_sw_out ) )  ALLOCATE( rad_sw_out(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_out',  tmp)
+          rad_sw_out(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_sw_out ) )  ALLOCATE( rad_sw_out(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_out',  rad_sw_out )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_out_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( radiation_scheme == 'clear-sky'  .OR.  radiation_scheme == 'constant'  .OR.            &
+            radiation_scheme == 'external' )  THEN
+          IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  ALLOCATE( rad_sw_out_av(0:0,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_out_av', tmp )
+          rad_sw_out_av(0,:,:) = tmp
+       ELSE
+          IF ( .NOT. ALLOCATED( rad_sw_out_av ) )  ALLOCATE( rad_sw_out_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+          CALL rrd_mpi_io( 'rad_sw_out_av', rad_sw_out_av )
+       ENDIF
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_cs_hr' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_sw_cs_hr ) )  ALLOCATE( rad_sw_cs_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_sw_cs_hr', rad_sw_cs_hr )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_cs_hr_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_sw_cs_hr_av ) )  ALLOCATE( rad_sw_cs_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_sw_cs_hr_av', rad_sw_cs_hr_av )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_hr' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_sw_hr ) )  ALLOCATE( rad_sw_hr(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_sw_hr', rad_sw_hr )
+    ENDIF
+
+    CALL rd_mpi_io_check_array( 'rad_sw_hr_av' , found = array_found )
+    IF ( array_found )  THEN
+       IF ( .NOT. ALLOCATED( rad_sw_hr_av ) )  ALLOCATE( rad_sw_hr_av(nzb:nzt+1,nysg:nyng,nxlg:nxrg) )
+       CALL rrd_mpi_io( 'rad_sw_hr_av', rad_sw_hr_av )
+    ENDIF
+
+ END SUBROUTINE radiation_rrd_local_mpi
 
  END MODULE radiation_model_mod
Index: palm/trunk/SOURCE/read_restart_data_mod.f90
===================================================================
--- palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4516)
+++ palm/trunk/SOURCE/read_restart_data_mod.f90	(revision 4517)
@@ -1147,5 +1147,5 @@
 
 !
-!--    Close restart File
+!--    Close restart file
        CALL rd_mpi_io_close
 
@@ -1376,5 +1376,5 @@
 ! Description:
 ! ------------
-!> Reads processor specific data of variables and arrays from restart file
+!> Reads processor (subdomain) specific data of variables and arrays from restart file
 !> (binary format).
 !------------------------------------------------------------------------------!
@@ -1385,4 +1385,5 @@
     CHARACTER (LEN=10) ::  binary_version_local
     CHARACTER (LEN=10) ::  version_on_file
+    CHARACTER (LEN=20) ::  tmp_name               !< temporary variable
 
     INTEGER(iwp) ::  files_to_be_opened  !<
@@ -1428,5 +1429,6 @@
     INTEGER(isp), DIMENSION(:,:,:), ALLOCATABLE ::  tmp_2d_seq_random  !< temporary array for storing random generator data
 
-    LOGICAL ::  found
+    LOGICAL ::  array_found                      !<
+    LOGICAL ::  found                            !<
 
     REAL(wp), DIMENSION(:,:),   ALLOCATABLE   ::  tmp_2d         !< temporary array for storing 2D data
